// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	dal "LAPP_ACURA_MOM_BACKEND/dao/jit"
	"LAPP_ACURA_MOM_BACKEND/db"
	"LAPP_ACURA_MOM_BACKEND/global"
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/jit"
	model "LAPP_ACURA_MOM_BACKEND/models/jit"
)

/******************************************************************************
 *
 * @Description              : PackTemplateItemLst的默认查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-19 10:26:40
 *
 ******************************************************************************/
var DefaultConditionOfPackTemplateItemLst = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.PackTemplateItemLst_PackTemplateId.UrlParameterName: grmi.NewConditionItem(meta.PackTemplateItemLst_PackTemplateId, grmi.Equal, true),
		meta.PackTemplateItemLst_Pos.UrlParameterName:            grmi.NewConditionItem(meta.PackTemplateItemLst_Pos, grmi.Equal, true),
		meta.PackTemplateItemLst_PosCode.UrlParameterName:        grmi.NewConditionItem(meta.PackTemplateItemLst_PosCode, grmi.Equal, false),
		meta.PackTemplateItemLst_PartId.UrlParameterName:         grmi.NewConditionItem(meta.PackTemplateItemLst_PartId, grmi.Equal, false),
		meta.PackTemplateItemLst_Seq.UrlParameterName:            grmi.NewConditionItem(meta.PackTemplateItemLst_Seq, grmi.Equal, false),
		meta.PackTemplateItemLst_PlanQty.UrlParameterName:        grmi.NewConditionItem(meta.PackTemplateItemLst_PlanQty, grmi.Equal, false),
		meta.PackTemplateItemLst_LastModify.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemLst_LastModify, grmi.Approximate, false),
		meta.PackTemplateItemLst_LastUser.UrlParameterName:       grmi.NewConditionItem(meta.PackTemplateItemLst_LastUser, grmi.Equal, false),
		meta.PackTemplateItemLst_CreateTime.UrlParameterName:     grmi.NewConditionItem(meta.PackTemplateItemLst_CreateTime, grmi.Approximate, false),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : PackTemplateItemLst的默认分页查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-19 10:26:40
 *
 ******************************************************************************/
var DefaultConditionOfPackTemplateItemLstAndPaging = grmi.NewCondition(
	DefaultConditionOfPackTemplateItemLst.Items,
	grmi.NewPaging(),
)

/******************************************************************************
 *
 * @Struct Name              : PackTemplateItemLstServiceImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : PackTemplateItemLst的服务实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-19 10:26:40
 *
 ******************************************************************************/
type PackTemplateItemLstServiceImplement struct {
}

/******************************************************************************
 *
 * @Function Name            : NewPackTemplateItemLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个PackTemplateItemLstDAOImplement实例
 *
 * @Return Value             : PackTemplateItemLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-19 10:26:40
 *
 ******************************************************************************/
func NewPackTemplateItemLstServiceImplement() *PackTemplateItemLstServiceImplement {
	return &PackTemplateItemLstServiceImplement{}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.InsertOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) InsertOne(user *global.User, entity *model.PackTemplateItemLst) error {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "InsertOnePackTemplateItemLst", "插入一个PackTemplateItemLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)
	record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.DeleteOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) DeleteOne(user *global.User, packTemplateId string, pos int) error {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "DeleteOnePackTemplateItemLst", "删除一个PackTemplateItemLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)
	record, err := dao.SelectOne(packTemplateId, pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(packTemplateId, pos)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.SelectOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) SelectOne(user *global.User, packTemplateId string, pos int) (*model.PackTemplateItemLst, error) {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "SelectOnePackTemplateItemLst", "查询一个PackTemplateItemLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)
	result, err := dao.SelectOne(packTemplateId, pos)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.UpdateOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) UpdateOne(user *global.User, entity *model.PackTemplateItemLst) error {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "UpdateOnePackTemplateItemLst", "修改一个PackTemplateItemLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)
	record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.Insert
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) Insert(user *global.User, entities *[]model.PackTemplateItemLst) error {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "InsertPackTemplateItemLst", "插入多个PackTemplateItemLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
		if err != nil {
			return err
		}
		if record != nil {
			return grmi.NewBusinessError("已经存在相同主键的记录!")
		}
	}

	err := dao.Insert(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.Delete
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) Delete(user *global.User, entities *[]model.PackTemplateItemLst) error {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "DeletePackTemplateItemLst", "删除多个PackTemplateItemLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Delete(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.Select
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) Select(user *global.User, urlParameters map[string]string) ([]model.PackTemplateItemLst, error) {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "SelectPackTemplateItemLst", "查询PackTemplateItemLst")

	condition := DefaultConditionOfPackTemplateItemLstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)
	result, err := dao.Select(predicates, condition.OrderByFields)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.SelectAndPaging
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) SelectAndPaging(user *global.User, urlParameters map[string]string) (grmi.PagingResult, error) {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "SelectPackTemplateItemLst", "查询PackTemplateItemLst")

	condition := DefaultConditionOfPackTemplateItemLstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)
	condition.Fill(urlParameters)
	result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/services/jit/PackTemplateItemLstService.Update
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstServiceImplement) Update(user *global.User, entities *[]model.PackTemplateItemLst) error {

	grmi.Log(user, "/services/jit/implments/PackTemplateItemLst.service.impl.go", "UpdatePackTemplateItemLst", "修改多个PackTemplateItemLst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackTemplateItemLstDAO(session, user.PlantNr, user.UserId)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackTemplateId, entity.Pos)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Update(entities)
	if err != nil {
		return err
	}
	return nil
}
